<?php

/*
 * Procontrol IPStecker 3, IPStecker 4 termkhez
 * php vezrlscript
 *
 * 2014.09.29- Procontrol Kft.
 * KR
 *
 * www.procontrol.hu
 * 2014.09.29
 * ver 1.1
 * 		Els kiadott verzi
 * 2016.01.11
 * ver 1.2
 * 		Kis hibajavts "
 *
*/
define("DEBUG_MSG", 100);

// A program azon rsze, amit a felhasznlnak rteni s hasznlnia kell:
$stecker0= new ipstecker();

// Kapcsolat felptse az eszkzzel
$result=$stecker0->connect("192.168.0.250", 80);
if ( $result )
{
	// Bejelentkezs
	$stecker0->ipstecker_login("admin");
}

// A kettes csatlakoz bekapcsolsa
$result=$stecker0->connect("192.168.0.250", 80);
if ( $result )
{
	$stecker0->ipstecker_set_connector(2,1);
}


// A hromas csatlakoz kikapcsolsa
$result=$stecker0->connect("192.168.0.250", 80);
if ( $result )
{
	$stecker0->ipstecker_set_connector(2,0);
}

// llapot lekrdezse egy tmbbe
$result=$stecker0->connect("192.168.0.250", 80);
if ( $result )
{
	$state=$stecker0->ipstecker_get_connector_status();
	var_dump($state);
	echo "Az egyes csatlakoz llapota: ".$state[1]."          (1=BE, 0=KI)";
}










	



// A rutinknyvtr ami a technikai kivitelezst elvgzi:
class ipstecker
{
    function __construct() {
        if (!extension_loaded('sockets')) {
            $comment = "The sockets php extension is not loaded. Exit now...";
            $this->clog($comment, ERROR_MSG);
            die($comment);
        }
	}

	public function connect( $host="127.0.0.1", $port, $timeout=3, $options = array() )
	{
		if ($host=="") $host="127.0.0.1";
		//$host = "udp://".$host;
		// A host el hasznlhatod a transport megadst is pl.: tcp:// , udp:// , 'udg:///dev/log (unix socket)' unix:///
		// http://www.php.net/manual/en/function.stream-socket-client.php
        $this->host = $host;
        $this->port = $port;
		$this->timeout = $timeout;
		$this->socket_options = $options;

        $errno = 0;
        $errstr = '';
		$this->clog("Connecting to server socket... : $host port: $port timeout: $timeout", DEBUG_MSG+100);
        $socket_context = stream_context_create($options);

		if ($port=="")
		{
			$connection_string = $host;
		} else
		{
			$connection_string = $host . ":" . $port;
		}
		
		if ( strstr($connection_string, "//", true)=="php:" )
		{
			$this->client_socket=fopen($connection_string, 'r');
		} else {
			//Suppress errors; connection failures are handled at a higher level
			$this->client_socket = @stream_socket_client(
				$connection_string,
				$errno_out,
				$errstr_out,
				$timeout,
				STREAM_CLIENT_CONNECT,
				//STREAM_CLIENT_ASYNC_CONNECT,
				//STREAM_CLIENT_PERSISTENT,
				$socket_context
			);
		}

        // Verify we connected properly
        if ( empty($this->client_socket) ) {
			$this->clog("client socket connect failed to host!!!! : $host port: $port errno: $errno_out", DEBUG_MSG+50);
			$this->client_socket_connect_failed_to_host($host,$port,$errno_out);
			$this->clog("socket error str: $errstr_out", DEBUG_MSG+300);

			$this->error = array(
                'error' => 'Failed to connect to server',
                'errno' => $errno_out,
                'errstr' => $errstr_out
            );
			$this->socket_connected=false;
			return false;
		} else
		{
			$this->clog("client socket connected. socket: ".var_export($this->client_socket, true)." is_resource: ".is_resource($this->client_socket), DEBUG_MSG+140);
			// Belltjuk nem blokkol zemmdba a socketet.
			//stream_set_blocking($this->client_socket, false);
			$this->socket_connected=true;
			$this->on_connected_to_socket();
        }

        // Socket server can take longer to respond, give longer timeout for first read
        // Windows does not have support for this timeout function
        if (substr(PHP_OS, 0, 3) != 'WIN') {
            $max = ini_get('max_execution_time');
            if ($max != 0 && $timeout > $max) { // Don't bother if unlimited
                @set_time_limit($timeout);
            }
            stream_set_timeout($this->client_socket, $timeout, 0);
        }

		$this->clog("Client socket connect sucess to host: $host port: $port", DEBUG_MSG+40);
		return true;
	}

	function write($c)
	{
		$result=$this->write_unsafe($c);
		$this->clog("socket_obj: ".var_export($this->client_socket, true)." write result: ".var_export($result, true)." is_resource: ".is_resource($this->client_socket), DEBUG_MSG+120);

		if ( $result===false )
		{
			$this->clog("Socket closed by other side!", DEBUG_MSG+100);
			$this->close();
			return false;
		} else
		{
			$this->clog("Write success! Write out $result bytes. Data: ".$c, DEBUG_MSG+80);
			$this->on_write_socket_data($c);
			return true;
		}

	}
	
    function write_unsafe($c) {
		//stream_set_write_buffer($this->client_socket, 0);
		// A kukaccal eltntetem a hibazeneteket!
		$result = @fwrite($this->client_socket, $c);
		return $result;
    }

	function get_unsafe()
	{
		$this->clog("Get read...", DEBUG_MSG+300);
		// A kukaccal eltntetem a hibazeneteket!
		$input_puffer = stream_get_contents($this->client_socket);
		return $input_puffer;
	}

	function close()
	{
		$result=fclose($this->client_socket);
	}

	function clog($message, $level=NULL)
	{
		echo $message."\n";
	}
	
	function client_socket_connect_failed_to_host($host,$port,$errno_out)
	{
		// Hibakezels
	}
	
	function on_connected_to_socket()
	{
		// Eredmny napl
	}
	
	function on_write_socket_data($c)
	{
		// Eredmny napl
	}

	function ipstecker_login($password)
	{
		//$data_login = "GET /login.cgi?loginpass=" . $password . " HTTP/1.1\r\n\r\n\r\n\r\n";
		$data_to_send = "POST /login.cgi HTTP/1.1\r\n".
							  "Content-Length: 40\r\n\r\n".
							  "loginpass=".$password."&sc=Bel%E9p%E9s";//.$set_state
		$this->write($data_to_send);
		$this->close;
	}

	function ipstecker_set_connector($conn_num, $set_state)
	{
		if ($set_state==1)
		{
			$set_state="ON";
		} else
		{
			$set_state="OFF";
		}
		//$data_set_connector = "GET /st_ctrl.cgi?plg". $conn_num ."_butt=ON / OFF" . " HTTP/1.1\r\n\r\n\r\n\r\n";//.$set_state
		$data_to_send = "POST /st_ctrl.cgi HTTP/1.1\r\n".
						"Content-Length: 20\r\n\r\n".
						//"plg". $conn_num ."_butt=ON2F+OFF";//.$set_state
						"plg". $conn_num ."_butt=".$set_state;
		$this->write($data_to_send);
		$this->close();
	}
	
	function ipstecker_get_connector_status()
	{
		$data_to_send = "GET /st_ctrl.cgi HTTP/1.1\r\n\r\n\r\n";
		$this->write($data_to_send);
		
		$webpage=$this->get_unsafe();
		//$webpage='meta name="plug_status" content="plg1=0;plg2=1;plg3=1;plg4=0"';
		
		$pattern='meta name="plug_status" content="';
		$result=strpos($webpage, $pattern);
		if ( $result !== false )
		{
			$state=substr($webpage, $result+strlen($pattern), 27);
			$state=str_replace("plg", "", $state);
			$state=explode(";", $state);
			foreach ( $state as $key=>$data )
			{
				$each=explode("=", $data);
				$state_ret[$each[0]]=$each[1];
			}
			return $state_ret;
		}
	}
}

/*

direkt relkapcsolshoz a kvetkez cgi parancs hasznlhat:

plg<sorszm>=<llapot>

sorszm: a kapcsoland dugalj sorszma, 1...4
llapot: ki, vagy be szeretnnk kapcsolni a dugaljat, 0=ki, 1=be

Pldul a "GET /st_ctrl.cgi?plg2=1 HTTP/1.1\r\n\r\n\r\n\r\n  bekapcsolja a 2-es dugaljt.


A relk llapota metaadatknt megjelenik a weblapban, a kvetkez formban:
<meta content="plg1=0;plg2=1;plg3=0;plg4=0" name="plug_status">

*/

?>
